﻿using System;
using System.ComponentModel;

namespace TextBoxExceptionValidation
{
    class ViewMode: INotifyPropertyChanged
    {
        private bool isValidated = true; // 默认为全部通过验证

        public event PropertyChangedEventHandler PropertyChanged;
        protected void InvokePropertyChanged(string property)
        {
            if (this.PropertyChanged != null)
            {
                this.PropertyChanged.Invoke(this, new PropertyChangedEventArgs(property));
            }
        }
       
        public bool IsValidated
        {
            get { return isValidated; }
            protected set { isValidated = value; }
        }
    }
    class Student:ViewMode
    {
        private string name;
        private double age;
        /// <summary>
        /// 姓名
        /// </summary>
        public string Name
        {
            get { return name; }
            set
            {
                if (!string.IsNullOrEmpty(value))
                {
                    name = value;
                    InvokePropertyChanged("Name");
                }
                else
                {
                    IsValidated = false;
                    throw new Exception("Name cannot be empty");
                }
            }
        }


        /// <summary>
        /// 年龄
        /// </summary>
        public double Age
        {
            get { return age; }
            set
            {
                if (value >=0 && value <= 150)
                {
                    age = value;
                    InvokePropertyChanged("Age");
                }
                else
                {
                    IsValidated = false;
                    throw new Exception("Age should between 0 and 150");
                }
            }
        }

    }

}
